
-- assume newlines are not begarbed

-- todo: utf8it

local freqs = {}
local file = io.open((arg[1] or "eso-off-topic.trim.txt"), "r")
for line in file:lines() do
	for c in line:gmatch(".") do
		freqs[c] = (freqs[c] or 0) + 1	
	end
end
file:close()

local lines = {}
local gecs = {}
for line in io.stdin:lines() do
	lines[#lines+1] = line
	for c in line:gmatch(".") do
		gecs[c] = (gecs[c] or 0) + 1
	end
end
io.stdin:close()

-- this is awful but no time
local function sorteet(m)
	local nl = {}
	for k,v in pairs(m) do
		nl[#nl+1] = {k,v}
	end
	table.sort(nl, function(a,b)
		return a[2] > b[2]
	end)
	local ln = {}
	for k,v in pairs(nl) do
		ln[#ln+1] = v[1]
	end
	return ln
end

local frome = sorteet(freqs)
local toe = sorteet(gecs)

local map = {}
for i,v in ipairs(frome) do
	map[v] = toe[i]
end

for i, line in ipairs(lines) do
	io.write(line:gsub(".", function(c) return map[c] end))
	io.write("\n")
end
